package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.item.ArrowItem;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;

public class SpectralShotAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.SpectralShotAffix> CODEC;
  
  protected final Map<LootRarity, StepFunction> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)GemBonus.VALUES_CODEC.fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.SpectralShotAffix::new));
  }
  
  public SpectralShotAffix(Map<LootRarity, StepFunction> values) {
    super(AffixType.ABILITY);
    this.values = values;
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (cat.isRanged() && this.values.containsKey(rarity));
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix." + getId() + ".desc", new Object[] { fmt(100.0F * getTrueLevel(rarity, level)) });
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    MutableComponent comp = getDescription(stack, rarity, level);
    MutableComponent mutableComponent1 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 0.0F)) });
    MutableComponent mutableComponent2 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 1.0F)) });
    return (Component)comp.m_7220_((Component)valueBounds((Component)mutableComponent1, (Component)mutableComponent2));
  }
  
  public void onArrowFired(ItemStack stack, LootRarity rarity, float level, LivingEntity user, AbstractArrow arrow) {
    if ((user.m_9236_()).f_46441_.m_188501_() <= getTrueLevel(rarity, level) && 
      !(user.m_9236_()).f_46443_) {
      ArrowItem arrowitem = (ArrowItem)Items.f_42737_;
      AbstractArrow spectralArrow = arrowitem.m_6394_(user.m_9236_(), ItemStack.f_41583_, user);
      spectralArrow.m_6686_(user.m_146909_(), user.m_146908_(), 0.0D, 2.0F, 1.0F);
      cloneMotion(arrow, spectralArrow);
      spectralArrow.m_36762_(arrow.m_36792_());
      spectralArrow.m_36781_(arrow.m_36789_());
      spectralArrow.m_36735_(arrow.f_36699_);
      spectralArrow.m_7311_(arrow.m_20094_());
      spectralArrow.f_36705_ = AbstractArrow.Pickup.CREATIVE_ONLY;
      spectralArrow.getPersistentData().m_128379_("apoth.generated", true);
      arrow.m_9236_().m_7967_((Entity)spectralArrow);
    } 
  }
  
  private void cloneMotion(AbstractArrow src, AbstractArrow dest) {
    dest.m_20256_(src.m_20184_().m_82490_(1.0D));
    dest.m_146922_(src.m_146908_());
    dest.m_146926_(src.m_146909_());
    dest.f_19859_ = dest.f_19859_;
    dest.f_19860_ = dest.f_19860_;
  }
  
  private float getTrueLevel(LootRarity rarity, float level) {
    return ((StepFunction)this.values.get(rarity)).get(level);
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
}
